
(*
  OCaml HTTP - do it yourself (fully OCaml) HTTP daemon

  Copyright (C) <2002-2004> Stefano Zacchiroli <zack@cs.unibo.it>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

let m = Mutex.create () in
let i = ref 10 in
let dump_i outchan =
  Http_daemon.respond ~body:(Printf.sprintf "i = %d\n" !i) outchan
in
let callback req outchan =
  match req#path with
  | "/incr" ->
      Mutex.lock m;
      incr i;
      dump_i outchan;
      Unix.sleep 5;
      Mutex.unlock m
  | "/decr" ->
      Mutex.lock m;
      decr i;
      dump_i outchan;
      Unix.sleep 5;
      Mutex.unlock m
  | "/get" ->
      Mutex.lock m;
      dump_i outchan;
      Mutex.unlock m
  | bad_request -> Http_daemon.respond_error outchan
in
Http_daemon.start' ~port:9999 ~mode:`Thread callback
